<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Attributes\Appends;
use Illuminate\Database\Eloquent\Attributes\Guarded;
use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\SoftDeletes;

#[Appends(['formatted_cutting_result', 'formatted_original_outside_sample', 'formatted_sample'])]
#[Guarded(['id'])]
class CuttingResult extends Model
{
    use HasFactory, SoftDeletes;

    protected function casts(): array
    {
        return [
            'cutting_result' => 'integer',
            'sample' => 'integer',
            'original_outside_sample' => 'integer',
        ];
    }

    protected function formattedCuttingResult(): Attribute
    {
        return Attribute::make(
            get: fn () => number_format($this->cutting_result, 0, ',', '.'),
        );
    }

    protected function formattedOriginalOutsideSample(): Attribute
    {
        return Attribute::make(
            get: fn () => number_format($this->original_outside_sample, 0, ',', '.'),
        );
    }

    protected function formattedSample(): Attribute
    {
        return Attribute::make(
            get: fn () => number_format($this->sample, 0, ',', '.'),
        );
    }

    public function cutting(): BelongsTo
    {
        return $this->belongsTo(Cutting::class);
    }

    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }
}
